<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Automate cellulaire:  Fichier source de src/automate.c</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Automate cellulaire
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Généré par Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Recherche');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Recherche');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">automate.c</div>  </div>
</div><!--header-->
<div class="contents">
<a href="automate_8c.html">Aller à la documentation de ce fichier.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;automate.h&quot;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">//                           Structure                        //</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00032"></a><span class="lineno"><a class="line" href="structautomate__cell.html">   32</a></span>&#160;<span class="comment"></span><span class="keyword">struct </span><a class="code" href="structautomate__cell.html">automate_cell</a>{</div>
<div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="structautomate__cell.html#aae7e723d96c29e9bbfc2c8f95886e85a">   33</a></span>&#160;  ptr_str_fc <a class="code" href="structautomate__cell.html#aae7e723d96c29e9bbfc2c8f95886e85a">f_config</a>;</div>
<div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="structautomate__cell.html#af27fecd3605ba100ac4c2a0b63aafab4">   34</a></span>&#160;  ptr_str_regle <a class="code" href="structautomate__cell.html#af27fecd3605ba100ac4c2a0b63aafab4">regle</a>;</div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="structautomate__cell.html#ad49bf24c5f929d1ed8e22fee5935834b">   35</a></span>&#160;  <span class="keywordtype">int</span>** <a class="code" href="structautomate__cell.html#ad49bf24c5f929d1ed8e22fee5935834b">tab</a>;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;};</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160; </div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">//                        Constructeur                        //</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="automate_8c.html#a117ebb3a717f9bbd035e7b295dcf26cb">   48</a></span>&#160;<span class="comment"></span>ptr_automate <a class="code" href="automate_8c.html#a117ebb3a717f9bbd035e7b295dcf26cb">creer_automate</a>(ptr_str_fc f_config){</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;  <span class="comment">// allouer de la memoire pour l&#39;automate</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;  ptr_automate automate_c = (ptr_automate) malloc(<span class="keyword">sizeof</span>(<span class="keyword">struct</span> <a class="code" href="structautomate__cell.html">automate_cell</a>));</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;  <span class="comment">// tester si la memoire est bien allouee</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;  <span class="keywordflow">if</span>(automate_c == NULL) {</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;     fprintf(stderr, <span class="stringliteral">&quot;L&#39;allocation memoire a echoue.&quot;</span>);</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;     exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;  }</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;  automate_c-&gt;f_config = f_config;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;  automate_c-&gt;regle = <a class="code" href="regle_8c.html#a66825a41280d604f6cd3c8b5f373a7ee">creer_regle</a>(<a class="code" href="fichier__configuration_8c.html#ae0ce5e18cc06c038b2ae5ab594e5e9e7">get_regle</a>(f_config), <a class="code" href="fichier__configuration_8c.html#afef69ee54144409041ea66d6e1185312">get_nb_etat</a>(f_config));</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;  <span class="keywordtype">char</span>* init_cell = <a class="code" href="fichier__configuration_8c.html#a21bb44a3b30408468720e6eb6eaa60ac">get_emplacement_initial</a>(f_config);</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160; </div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;  <span class="comment">// allouer de la memoire pour le tableau des etats de chaque cellule</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;  <span class="keywordtype">int</span>** tab = (<span class="keywordtype">int</span>**) malloc(<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>*) * (<a class="code" href="fichier__configuration_8c.html#afc113bc5216673e023757de45be2e009">get_hauteur</a>(f_config) + 1));</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;  <span class="keywordflow">if</span>(tab == NULL) {</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;       fprintf(stderr, <span class="stringliteral">&quot;L&#39;allocation memoire a echoue.&quot;</span>);</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;       exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;   }</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160; </div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; <a class="code" href="fichier__configuration_8c.html#afc113bc5216673e023757de45be2e009">get_hauteur</a>(f_config) + 1; i++) {</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    tab[i] = (<span class="keywordtype">int</span>*) malloc(<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>) * <a class="code" href="fichier__configuration_8c.html#a1b660f6a0cca911778798dfe26976cdd">get_largeur</a>(f_config));</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keywordflow">if</span>(tab[i] == NULL) {</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;       fprintf(stderr, <span class="stringliteral">&quot;L&#39;allocation memoire a echoue.&quot;</span>);</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;       exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    }</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;  }</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;  <span class="comment">// stocker la configuration initiale</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> j = 0; j &lt; <a class="code" href="fichier__configuration_8c.html#a1b660f6a0cca911778798dfe26976cdd">get_largeur</a>(automate_c-&gt;f_config); j++) {</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    tab[0][j] = (int)(init_cell[j] - <span class="charliteral">&#39;0&#39;</span>);</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;  }</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;  automate_c-&gt;tab = tab;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;  <span class="keywordflow">return</span> automate_c;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;}</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160; </div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160; </div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="comment">//                       Autres Fonctions                     //</span></div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00092"></a><span class="lineno"><a class="line" href="automate_8c.html#aa3e1c93736b3bc4efedcb6a9846b1889">   92</a></span>&#160;<span class="comment"></span><span class="keywordtype">void</span> <a class="code" href="automate_8c.html#aa3e1c93736b3bc4efedcb6a9846b1889">evoluer</a>(ptr_automate automate){</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;  ptr_str_conf conf = <a class="code" href="configuration_8c.html#a2da1ecaa0c8bee5b0de11c7a0cf25376">creer_configuration</a>();</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;  <span class="comment">// parcourir chaque ligne de l&#39;automate</span></div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; <a class="code" href="fichier__configuration_8c.html#afc113bc5216673e023757de45be2e009">get_hauteur</a>(automate-&gt;f_config); i++) {</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="comment">// parcourir chaque cellule d&#39;une ligne</span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> j = 0; j &lt; <a class="code" href="fichier__configuration_8c.html#a1b660f6a0cca911778798dfe26976cdd">get_largeur</a>(automate-&gt;f_config); j++) {</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;      <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> gauche;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;      <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> centre;</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;      <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> droite;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;      <span class="comment">// stocke la valeur des cellules voisines et de la cellule actuelle</span></div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;      centre = automate-&gt;tab[i][j];</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;      <span class="keywordflow">if</span> (j == 0){</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;          gauche = automate-&gt;tab[i][<a class="code" href="fichier__configuration_8c.html#a1b660f6a0cca911778798dfe26976cdd">get_largeur</a>(automate-&gt;f_config)-1];</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;          droite = automate-&gt;tab[i][j+1];</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;      }</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;      <span class="keywordflow">else</span> <span class="keywordflow">if</span>(j == <a class="code" href="fichier__configuration_8c.html#a1b660f6a0cca911778798dfe26976cdd">get_largeur</a>(automate-&gt;f_config) - 1){</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;          gauche = automate-&gt;tab[i][j-1];</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;          droite = automate-&gt;tab[i][0];</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;      }</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;      <span class="keywordflow">else</span>{</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        gauche = automate-&gt;tab[i][j-1];</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        droite = automate-&gt;tab[i][j+1];</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;      }</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;      <span class="comment">// Automates cellulaires élémentaires</span></div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;      <span class="comment">// on initialise une configuration avec les cellules voisines</span></div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;      <span class="comment">// et la cellule actuelle,</span></div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;      <span class="comment">// puis on cherche la configuration qui corresponde a la configuration</span></div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;      <span class="comment">// creee afin de recuperer la valeur de sortie de la configuration</span></div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;      <span class="keywordflow">if</span> (<a class="code" href="regle_8c.html#a46e5c74eda89fcaf925f91806d5bf86c">get_nombre_etat</a>(automate-&gt;regle) == 2){</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        <a class="code" href="configuration_8c.html#a8683ab4db526e75f84e627323f8a4b01">init_configuration_entree</a>(conf, gauche, centre, droite);</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        automate-&gt;tab[i+1][j] = <a class="code" href="regle_8c.html#a73aeb391bdf6be3f730c3d725360257a">recherche_configuration</a>(automate-&gt;regle, conf);</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;      }</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;      <span class="comment">// Etats supplementaires</span></div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;      <span class="comment">// on calcul la somme des voisins (cellule comprise) qui donne l&#39;indice</span></div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;      <span class="comment">// que l&#39;on va utiliser pour chercher dans le tableau de la regle</span></div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;      <span class="keywordflow">else</span>{</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> somme = gauche + centre + droite;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        automate-&gt;tab[i+1][j] = <a class="code" href="regle_8c.html#ad852e50dfdd6aa3660731b37de177d2c">recherche_indice</a>(automate-&gt;regle, somme);</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;      }</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    }</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;  }</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;  free(conf);</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160; </div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;}</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160; </div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160; </div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;<span class="comment">//                        Destruction                         //</span></div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00147"></a><span class="lineno"><a class="line" href="automate_8c.html#aa3ba78ebbf6cec54e6e4e0fa0fced8ee">  147</a></span>&#160;<span class="comment"></span><span class="keywordtype">void</span> <a class="code" href="automate_8c.html#aa3ba78ebbf6cec54e6e4e0fa0fced8ee">delete_automate</a>(ptr_automate* ptr){</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;  <a class="code" href="regle_8c.html#a12710fa473da40d460ea41037c23ade9">delete_regle</a>(&amp;((*ptr)-&gt;regle));</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; <a class="code" href="fichier__configuration_8c.html#afc113bc5216673e023757de45be2e009">get_hauteur</a>((*ptr)-&gt;f_config) + 1; i++) {</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    free((*ptr)-&gt;tab[i]);</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;  }</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;  free((*ptr)-&gt;tab);</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;  free((*ptr));</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;  *ptr = NULL;</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;}</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160; </div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160; </div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;<span class="comment">//                          Affichage                         //</span></div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00166"></a><span class="lineno"><a class="line" href="automate_8c.html#a9fdbceb307999d064bf86f99d3598539">  166</a></span>&#160;<span class="comment"></span><span class="keywordtype">void</span> <a class="code" href="automate_8c.html#a9fdbceb307999d064bf86f99d3598539">_affiche_automate_terminal_somme</a>(ptr_automate automate) {</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;  printf(<span class="stringliteral">&quot;Regle : %s\n&quot;</span>, <a class="code" href="regle_8c.html#ab5f4f5a6960efe9d383d86c67c4f7190">get_numero_binaire</a>(automate-&gt;regle));</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;  printf(<span class="stringliteral">&quot;Nombre d&#39;iterations : %d\n&quot;</span>, <a class="code" href="fichier__configuration_8c.html#afc113bc5216673e023757de45be2e009">get_hauteur</a>(automate-&gt;f_config));</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; <a class="code" href="fichier__configuration_8c.html#afc113bc5216673e023757de45be2e009">get_hauteur</a>(automate-&gt;f_config)+1; i++) {</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    printf(<span class="stringliteral">&quot;|%2ld|&quot;</span>, i);</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> j = 0; j &lt; <a class="code" href="fichier__configuration_8c.html#a1b660f6a0cca911778798dfe26976cdd">get_largeur</a>(automate-&gt;f_config); j++) {</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;      <span class="keywordflow">if</span> (automate-&gt;tab[i][j] == 0){</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        printf(<span class="stringliteral">&quot; &quot;</span>);</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;      }</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;      <span class="keywordflow">else</span>{</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        printf(<span class="stringliteral">&quot;%d&quot;</span>, automate-&gt;tab[i][j]);</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;      }</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    }</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    printf(<span class="stringliteral">&quot;\n&quot;</span>);</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;  }</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;}</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160; </div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160; </div>
<div class="line"><a name="l00189"></a><span class="lineno"><a class="line" href="automate_8c.html#a320cea72ddfeeb38cef103fff39e31b4">  189</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="automate_8c.html#a320cea72ddfeeb38cef103fff39e31b4">_affiche_automate_image</a>( ptr_automate automate ){</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;  FILE* fichier = <a class="code" href="image_8c.html#af3ac482597fe1d1d8fdad40e3119b896">creer_image</a>( automate-&gt;f_config );</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;  <a class="code" href="image_8c.html#a1251ec097153c17cdf6ef77b20e7eceb">ecrire_entete_image</a>(fichier, automate-&gt;f_config);</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> NOMBRE_MAGIQUE = <a class="code" href="fichier__configuration_8c.html#af66f6107d4b7f6e4de23bd6f697ccaf8">get_nb_magique</a>( automate-&gt;f_config );</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;  <span class="keywordflow">switch</span> (NOMBRE_MAGIQUE){</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    <span class="keywordflow">case</span> 2:</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;      <a class="code" href="image_8c.html#a9aac53703bab191011d8c1b8ec52b630">ecrire_donnees_image_ascii</a>(fichier, automate-&gt;f_config, &amp;automate-&gt;tab);</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;      <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160; </div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    <span class="keywordflow">case</span> 5:</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;      <a class="code" href="image_8c.html#a15ea0f80adae8f83b853c427a2254ae8">ecrire_donnees_image_binaire</a>(fichier, automate-&gt;f_config, &amp;automate-&gt;tab);</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;      <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160; </div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    <span class="keywordflow">default</span>:</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;      fprintf(stderr, <span class="stringliteral">&quot;Le nombre magique est incorecte pour des images PGM.&quot;</span>);</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;      exit( EXIT_FAILURE );</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;      <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;  }</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;  <span class="keywordtype">char</span>* format;</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;  <span class="keywordflow">if</span> (<a class="code" href="fichier__configuration_8c.html#af66f6107d4b7f6e4de23bd6f697ccaf8">get_nb_magique</a>(automate-&gt;f_config) == 5){</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    format = <span class="stringliteral">&quot;binaire&quot;</span>;</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;  }</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;  <span class="keywordflow">else</span>{</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;    format = <span class="stringliteral">&quot;ascii&quot;</span>;</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;  }</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;  printf(<span class="stringliteral">&quot;L&#39;image PGM en %s \&quot;regle_%s.pgm\&quot; a été créé.\nLe fichier est enregistré dans le dossier img.\n&quot;</span>, format, <a class="code" href="fichier__configuration_8c.html#ae0ce5e18cc06c038b2ae5ab594e5e9e7">get_regle</a>(automate-&gt;f_config));</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;  fclose( fichier );</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;}</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160; </div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160; </div>
<div class="line"><a name="l00225"></a><span class="lineno"><a class="line" href="automate_8c.html#ab13ad43eea87c41a9a080239a0887a7f">  225</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="automate_8c.html#ab13ad43eea87c41a9a080239a0887a7f">_affiche_automate_terminal_binaire</a>(ptr_automate automate) {</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;  printf(<span class="stringliteral">&quot;Regle : %u\n&quot;</span>, <a class="code" href="regle_8c.html#abb64bb8f15528e167294857d015a193a">get_numero_decimale</a>(automate-&gt;regle));</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;  printf(<span class="stringliteral">&quot;Regle binaire : %s\n&quot;</span>, <a class="code" href="regle_8c.html#ab5f4f5a6960efe9d383d86c67c4f7190">get_numero_binaire</a>(automate-&gt;regle));</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;  printf(<span class="stringliteral">&quot;Nombre d&#39;iterations : %d\n&quot;</span>, <a class="code" href="fichier__configuration_8c.html#afc113bc5216673e023757de45be2e009">get_hauteur</a>(automate-&gt;f_config));</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;  <span class="keywordtype">char</span> symbole = <a class="code" href="fichier__configuration_8c.html#a50675bf48ff97d3282760437d7e9c69e">get_cellule_symbole</a>(automate-&gt;f_config);</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; <a class="code" href="fichier__configuration_8c.html#afc113bc5216673e023757de45be2e009">get_hauteur</a>(automate-&gt;f_config)+1; i++) {</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;    printf(<span class="stringliteral">&quot;|%2ld|&quot;</span>, i);</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> j = 0; j &lt; <a class="code" href="fichier__configuration_8c.html#a1b660f6a0cca911778798dfe26976cdd">get_largeur</a>(automate-&gt;f_config); j++) {</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;      <span class="keywordflow">if</span> (automate-&gt;tab[i][j] == 0){</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;        printf(<span class="stringliteral">&quot; &quot;</span>);</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;      }</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;      <span class="keywordflow">else</span>{</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;        printf(<span class="stringliteral">&quot;%c&quot;</span>, symbole);</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;      }</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;    }</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;    printf(<span class="stringliteral">&quot;\n&quot;</span>);</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;  }</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;}</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160; </div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160; </div>
<div class="line"><a name="l00251"></a><span class="lineno"><a class="line" href="automate_8c.html#a5739d8a1c873eea2c0a1099cc20ea7ef">  251</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="automate_8c.html#a5739d8a1c873eea2c0a1099cc20ea7ef">affiche_automate</a>(ptr_automate automate, <span class="keywordtype">void</span>(*_affiche)(ptr_automate)){</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;  (*_affiche)(automate);</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;}</div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aregle_8c_html_a12710fa473da40d460ea41037c23ade9"><div class="ttname"><a href="regle_8c.html#a12710fa473da40d460ea41037c23ade9">delete_regle</a></div><div class="ttdeci">void delete_regle(ptr_str_regle *ptr)</div><div class="ttdoc">Desallouer la memoire de la regle.</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00226">regle.c:226</a></div></div>
<div class="ttc" id="aautomate_8c_html_a5739d8a1c873eea2c0a1099cc20ea7ef"><div class="ttname"><a href="automate_8c.html#a5739d8a1c873eea2c0a1099cc20ea7ef">affiche_automate</a></div><div class="ttdeci">void affiche_automate(ptr_automate automate, void(*_affiche)(ptr_automate))</div><div class="ttdoc">Fonction generique permettant d'afficher differemment l'automate.</div><div class="ttdef"><b>Definition:</b> <a href="automate_8c_source.html#l00251">automate.c:251</a></div></div>
<div class="ttc" id="aimage_8c_html_a15ea0f80adae8f83b853c427a2254ae8"><div class="ttname"><a href="image_8c.html#a15ea0f80adae8f83b853c427a2254ae8">ecrire_donnees_image_binaire</a></div><div class="ttdeci">void ecrire_donnees_image_binaire(FILE *fichier, ptr_str_fc f_config, int ***tableau)</div><div class="ttdoc">Ecrit les données d'une image PGM dans un format binaire (nombre magique P5)</div><div class="ttdef"><b>Definition:</b> <a href="image_8c_source.html#l00101">image.c:101</a></div></div>
<div class="ttc" id="astructautomate__cell_html"><div class="ttname"><a href="structautomate__cell.html">automate_cell</a></div><div class="ttdoc">Un automate cellulaire.</div><div class="ttdef"><b>Definition:</b> <a href="automate_8c_source.html#l00032">automate.c:32</a></div></div>
<div class="ttc" id="aautomate_8c_html_a9fdbceb307999d064bf86f99d3598539"><div class="ttname"><a href="automate_8c.html#a9fdbceb307999d064bf86f99d3598539">_affiche_automate_terminal_somme</a></div><div class="ttdeci">void _affiche_automate_terminal_somme(ptr_automate automate)</div><div class="ttdoc">Affiche les attributs de la structure automate_cell.</div><div class="ttdef"><b>Definition:</b> <a href="automate_8c_source.html#l00166">automate.c:166</a></div></div>
<div class="ttc" id="aconfiguration_8c_html_a2da1ecaa0c8bee5b0de11c7a0cf25376"><div class="ttname"><a href="configuration_8c.html#a2da1ecaa0c8bee5b0de11c7a0cf25376">creer_configuration</a></div><div class="ttdeci">ptr_str_conf creer_configuration()</div><div class="ttdoc">Créer une structure configuration en initialisant ses valeurs à 0.</div><div class="ttdef"><b>Definition:</b> <a href="configuration_8c_source.html#l00048">configuration.c:48</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_afc113bc5216673e023757de45be2e009"><div class="ttname"><a href="fichier__configuration_8c.html#afc113bc5216673e023757de45be2e009">get_hauteur</a></div><div class="ttdeci">unsigned int get_hauteur(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;hauteur&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00111">fichier_configuration.c:111</a></div></div>
<div class="ttc" id="aconfiguration_8c_html_a8683ab4db526e75f84e627323f8a4b01"><div class="ttname"><a href="configuration_8c.html#a8683ab4db526e75f84e627323f8a4b01">init_configuration_entree</a></div><div class="ttdeci">void init_configuration_entree(ptr_str_conf ptr, unsigned int gauche, unsigned int centre, unsigned int droite)</div><div class="ttdoc">Initialise les valeurs pour une structure configuration donnée.</div><div class="ttdef"><b>Definition:</b> <a href="configuration_8c_source.html#l00073">configuration.c:73</a></div></div>
<div class="ttc" id="aimage_8c_html_a9aac53703bab191011d8c1b8ec52b630"><div class="ttname"><a href="image_8c.html#a9aac53703bab191011d8c1b8ec52b630">ecrire_donnees_image_ascii</a></div><div class="ttdeci">void ecrire_donnees_image_ascii(FILE *fichier, ptr_str_fc f_config, int ***tableau)</div><div class="ttdoc">Ecrit les données d'une image PGM dans un format ASCII (nombre magique P2).</div><div class="ttdef"><b>Definition:</b> <a href="image_8c_source.html#l00084">image.c:84</a></div></div>
<div class="ttc" id="aimage_8c_html_a1251ec097153c17cdf6ef77b20e7eceb"><div class="ttname"><a href="image_8c.html#a1251ec097153c17cdf6ef77b20e7eceb">ecrire_entete_image</a></div><div class="ttdeci">void ecrire_entete_image(FILE *fichier, ptr_str_fc f_config)</div><div class="ttdoc">Ecrit dans l'en-tête de l'image passé en paramètres les éléments définit au préalable dans le fichier...</div><div class="ttdef"><b>Definition:</b> <a href="image_8c_source.html#l00058">image.c:58</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_a1b660f6a0cca911778798dfe26976cdd"><div class="ttname"><a href="fichier__configuration_8c.html#a1b660f6a0cca911778798dfe26976cdd">get_largeur</a></div><div class="ttdeci">unsigned int get_largeur(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;largeur&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00122">fichier_configuration.c:122</a></div></div>
<div class="ttc" id="astructautomate__cell_html_af27fecd3605ba100ac4c2a0b63aafab4"><div class="ttname"><a href="structautomate__cell.html#af27fecd3605ba100ac4c2a0b63aafab4">automate_cell::regle</a></div><div class="ttdeci">ptr_str_regle regle</div><div class="ttdef"><b>Definition:</b> <a href="automate_8c_source.html#l00034">automate.c:34</a></div></div>
<div class="ttc" id="aregle_8c_html_ab5f4f5a6960efe9d383d86c67c4f7190"><div class="ttname"><a href="regle_8c.html#ab5f4f5a6960efe9d383d86c67c4f7190">get_numero_binaire</a></div><div class="ttdeci">char * get_numero_binaire(ptr_str_regle ptr)</div><div class="ttdoc">Retourne l'attribut &quot;numero_binaire&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00203">regle.c:203</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_afef69ee54144409041ea66d6e1185312"><div class="ttname"><a href="fichier__configuration_8c.html#afef69ee54144409041ea66d6e1185312">get_nb_etat</a></div><div class="ttdeci">unsigned int get_nb_etat(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;nb_etat&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00100">fichier_configuration.c:100</a></div></div>
<div class="ttc" id="aautomate_8c_html_a117ebb3a717f9bbd035e7b295dcf26cb"><div class="ttname"><a href="automate_8c.html#a117ebb3a717f9bbd035e7b295dcf26cb">creer_automate</a></div><div class="ttdeci">ptr_automate creer_automate(ptr_str_fc f_config)</div><div class="ttdoc">Créer un automate appartir des dnnées de configuration (structure fichier_configuration)</div><div class="ttdef"><b>Definition:</b> <a href="automate_8c_source.html#l00048">automate.c:48</a></div></div>
<div class="ttc" id="aregle_8c_html_a66825a41280d604f6cd3c8b5f373a7ee"><div class="ttname"><a href="regle_8c.html#a66825a41280d604f6cd3c8b5f373a7ee">creer_regle</a></div><div class="ttdeci">ptr_str_regle creer_regle(char *numero, unsigned int nombre_etat)</div><div class="ttdoc">Créer une structure regle.</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00105">regle.c:105</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_a50675bf48ff97d3282760437d7e9c69e"><div class="ttname"><a href="fichier__configuration_8c.html#a50675bf48ff97d3282760437d7e9c69e">get_cellule_symbole</a></div><div class="ttdeci">char get_cellule_symbole(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;cellule_symbole&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00133">fichier_configuration.c:133</a></div></div>
<div class="ttc" id="aautomate_8c_html_ab13ad43eea87c41a9a080239a0887a7f"><div class="ttname"><a href="automate_8c.html#ab13ad43eea87c41a9a080239a0887a7f">_affiche_automate_terminal_binaire</a></div><div class="ttdeci">void _affiche_automate_terminal_binaire(ptr_automate automate)</div><div class="ttdoc">Fonction générique perrmettant d'afficher dans le terminal avec des symboles (ex: X,...</div><div class="ttdef"><b>Definition:</b> <a href="automate_8c_source.html#l00225">automate.c:225</a></div></div>
<div class="ttc" id="aregle_8c_html_abb64bb8f15528e167294857d015a193a"><div class="ttname"><a href="regle_8c.html#abb64bb8f15528e167294857d015a193a">get_numero_decimale</a></div><div class="ttdeci">unsigned int get_numero_decimale(ptr_str_regle ptr)</div><div class="ttdoc">Retourne l'attribut &quot;numero_decimale&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00192">regle.c:192</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_af66f6107d4b7f6e4de23bd6f697ccaf8"><div class="ttname"><a href="fichier__configuration_8c.html#af66f6107d4b7f6e4de23bd6f697ccaf8">get_nb_magique</a></div><div class="ttdeci">unsigned int get_nb_magique(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;nb_magique&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00167">fichier_configuration.c:167</a></div></div>
<div class="ttc" id="aregle_8c_html_a46e5c74eda89fcaf925f91806d5bf86c"><div class="ttname"><a href="regle_8c.html#a46e5c74eda89fcaf925f91806d5bf86c">get_nombre_etat</a></div><div class="ttdeci">unsigned int get_nombre_etat(ptr_str_regle ptr)</div><div class="ttdoc">Retourne l'attribut &quot;nombre_etat&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00181">regle.c:181</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_a21bb44a3b30408468720e6eb6eaa60ac"><div class="ttname"><a href="fichier__configuration_8c.html#a21bb44a3b30408468720e6eb6eaa60ac">get_emplacement_initial</a></div><div class="ttdeci">char * get_emplacement_initial(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;emplacement_initial&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00144">fichier_configuration.c:144</a></div></div>
<div class="ttc" id="aregle_8c_html_ad852e50dfdd6aa3660731b37de177d2c"><div class="ttname"><a href="regle_8c.html#ad852e50dfdd6aa3660731b37de177d2c">recherche_indice</a></div><div class="ttdeci">int recherche_indice(ptr_str_regle regle, unsigned int indice)</div><div class="ttdoc">Trouve la valeur de la sortie a partir de l'indice donnee en parametre.</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00167">regle.c:167</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_ae0ce5e18cc06c038b2ae5ab594e5e9e7"><div class="ttname"><a href="fichier__configuration_8c.html#ae0ce5e18cc06c038b2ae5ab594e5e9e7">get_regle</a></div><div class="ttdeci">char * get_regle(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;regle&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00089">fichier_configuration.c:89</a></div></div>
<div class="ttc" id="astructautomate__cell_html_ad49bf24c5f929d1ed8e22fee5935834b"><div class="ttname"><a href="structautomate__cell.html#ad49bf24c5f929d1ed8e22fee5935834b">automate_cell::tab</a></div><div class="ttdeci">int ** tab</div><div class="ttdef"><b>Definition:</b> <a href="automate_8c_source.html#l00035">automate.c:35</a></div></div>
<div class="ttc" id="aimage_8c_html_af3ac482597fe1d1d8fdad40e3119b896"><div class="ttname"><a href="image_8c.html#af3ac482597fe1d1d8fdad40e3119b896">creer_image</a></div><div class="ttdeci">FILE * creer_image(ptr_str_fc f_config)</div><div class="ttdoc">Crée un fichier image au format (.pgm) ainsi qu'un pointeur de fichier.</div><div class="ttdef"><b>Definition:</b> <a href="image_8c_source.html#l00025">image.c:25</a></div></div>
<div class="ttc" id="aautomate_8c_html_aa3ba78ebbf6cec54e6e4e0fa0fced8ee"><div class="ttname"><a href="automate_8c.html#aa3ba78ebbf6cec54e6e4e0fa0fced8ee">delete_automate</a></div><div class="ttdeci">void delete_automate(ptr_automate *ptr)</div><div class="ttdoc">Désaloue la mémoire des attributs de la structure automate_cell, la structure elle même et son pointe...</div><div class="ttdef"><b>Definition:</b> <a href="automate_8c_source.html#l00147">automate.c:147</a></div></div>
<div class="ttc" id="aautomate_8c_html_aa3e1c93736b3bc4efedcb6a9846b1889"><div class="ttname"><a href="automate_8c.html#aa3e1c93736b3bc4efedcb6a9846b1889">evoluer</a></div><div class="ttdeci">void evoluer(ptr_automate automate)</div><div class="ttdoc">Faire évoluer les ceellules de l'automate appartir d'une règle.</div><div class="ttdef"><b>Definition:</b> <a href="automate_8c_source.html#l00092">automate.c:92</a></div></div>
<div class="ttc" id="aautomate_8c_html_a320cea72ddfeeb38cef103fff39e31b4"><div class="ttname"><a href="automate_8c.html#a320cea72ddfeeb38cef103fff39e31b4">_affiche_automate_image</a></div><div class="ttdeci">void _affiche_automate_image(ptr_automate automate)</div><div class="ttdoc">Crée une mage PGM, stock le résultat de l'automate et enregistre l'image.</div><div class="ttdef"><b>Definition:</b> <a href="automate_8c_source.html#l00189">automate.c:189</a></div></div>
<div class="ttc" id="aregle_8c_html_a73aeb391bdf6be3f730c3d725360257a"><div class="ttname"><a href="regle_8c.html#a73aeb391bdf6be3f730c3d725360257a">recherche_configuration</a></div><div class="ttdeci">int recherche_configuration(ptr_str_regle regle, ptr_str_conf conf)</div><div class="ttdoc">Trouve la valeur de la sortie de la configuration passé en paramètre à partir d'une configuration ide...</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00149">regle.c:149</a></div></div>
<div class="ttc" id="astructautomate__cell_html_aae7e723d96c29e9bbfc2c8f95886e85a"><div class="ttname"><a href="structautomate__cell.html#aae7e723d96c29e9bbfc2c8f95886e85a">automate_cell::f_config</a></div><div class="ttdeci">ptr_str_fc f_config</div><div class="ttdef"><b>Definition:</b> <a href="automate_8c_source.html#l00033">automate.c:33</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Généré par &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
